'Compilable Example:
#Compiler PBWin 10
#Compile Exe "dlltest.exe"
#Dim All
%Unicode = 1
#Include "win32api.inc"

#Resource Icon logo "files\settings.ico"

'declare the only exported function from the DLL
Declare Sub gViewer Lib "gbmultiviewer.dll" Alias "gViewer" ( _
      gTitle As WStringZ * %Max_Path, _        'title to use in dialog
      gParent As Dword, _                      'handle to parent of viewer dialog
      gFileList As String, _                   'file list, semicolon separated
      gLogo As WStringZ * %Max_Path, _         'resource icon for gbMultiViewer dialog
      gUnsupported As WStringZ * %Max_Path, _  'resource icon for unsupported file types
      gx As Long, _            'x position relative to parent upper-left
      gy As Long, _            'y position relative to parent upper-left
      gw As Long, _            'viewer width
      gh As Long, _            'viewer height
      gColumns As Long, _      'columns
      gRows As Long, _         'rows
      gCIDmin As Long, _       'control ID starting value
      gBGColor As Long, _      'background color
      gStretched As Long, _    'dislpay mode 0-upperleft 1-center/resized(stretched)
      gShownames As Long, _    'show names   0-no 1-yes
      gShowborders As Long, _  'show borders 0-no 1-yes
      gShowpaths As Long, _    'show paths in filename 0-no 1-yes
      gTransparent As Long, _  'transparent image background
      gAutoSetRC As Long, _    'calculate row/column values for best fit
      gAutoRefresh As Long, _  'auto refresh file display
      gRefreshRate As Long, _  'refresh period (seconds)
      gUseini As Long)  'use INI file 0-no 1-yes

%IDC_Button = 500
Global hDlg As Dword

Function PBMain() As Long
   Dialog New Pixels, 0, "Simple gbMultiViewer DLL Test",300,300,300,100, %WS_OverlappedWindow To hDlg
   Dialog Set Icon hDlg, "logo"
   Control Add Button, hDlg, %IDC_Button,"Select Folder", 50,30,100,20
   Dialog Show Modal hDlg Call DlgProc
End Function

CallBack Function DlgProc() As Long
   Select Case Cb.Msg
      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDC_Button :  ShowFiles
         End Select
   End Select
End Function

Function SelectFolder() As String
   Local title$, start$, flags&, folder$, sfolder$
   sFolder$ = Exe.Path$
   title$ = "Select Folder"
   start$ = Exe.Path$
   flags& = %BIF_ReturnOnlyFSDirs Or %BIF_DontGoBelowDomain Or %BIF_NoNewFolderButton
   Display Browse  hDlg, 100, 100, title$, start$, flags& To folder$   ' "" if Cancel/Escape is pressed
   Function = folder$
End Function

Sub ShowFiles
   Local FileList, FileName, Folder As String

   'select folder
   Folder = SelectFolder
   If Len(Folder) = 0 Then Exit Sub

   'create file list from folder
   FileName = Dir$(Folder + "\*.*")
   While Len(FileName)
      FileList = Folder + "\" + FileName + ";" + FileList
      FileName = Dir$
   Wend
   FileList = Trim$(FileList,";")
   If Len(FileList) = 0 Then MsgBox "No files found!", %MB_Ok + %MB_IconExclamation, "View Files" : Exit Sub

   'open the viewer using the file list
   gViewer "gbMultiViewer DLL Test", _   'title to use in dialog
           hDlg, _      'parent handle
           FileList, _  'file list, semicolon separated
           "", _        'resource icon for gbMultiViewer dialog
           "", _        'resource icon for unsupported file types
           100, _       'x position relative to parent upper-left
           100, _       'y position relative to parent upper-left
           400, _       'viewer width
           400, _       'viewer height
           3, _         'columns
           3, _         'rows
           5000, _      'control ID starting value
           %White, _    'background color
           0, _         'display mode  0-upperleft 1-center/resized(stretched)
           1, _         'show names    0-no 1-yes
           1, _         'show borders  0-no 1-yes
           0, _         'show paths in filename 0-no 1-yes
           0, _         'transparent image background
           1, _         'calculate row/column values for best fit
           0, _         'automatically refreshes dislayed files
           10, _        'refresh period (seconds)
           1            'use INI file  0-no 1-yes
End Sub
