'Compilable Example:
#Compiler PBWin 10
#Compile Exe "gbmultiviewer.exe"
#Dim All
#Debug Error On
#Debug Display On
%Unicode = 1
#Include "win32api.inc"

Declare Sub gViewer Lib "gbmultiviewer.dll" Alias "gViewer" ( _
      gTitle As WStringZ * %Max_Path, _        'title to use in dialog
      gParent As Dword, _                      'handle to parent of viewer dialog
      gFileList As String, _                   'file list, semicolon separated
      gLogo As WStringZ * %Max_Path, _         'resource icon for gbMultiViewer dialog
      gUnsupported As WStringZ * %Max_Path, _  'resource icon for unsupported file types
      gx As Long, _            'x position relative to parent upper-left
      gy As Long, _            'y position relative to parent upper-left
      gw As Long, _            'viewer width
      gh As Long, _            'viewer height
      gColumns As Long, _      'columns
      gRows As Long, _         'rows
      gCIDmin As Long, _       'control ID starting value
      gBGColor As Long, _      'background color
      gStretched As Long, _    'dislpay mode 0-upperleft 1-center/resized(stretched)
      gShownames As Long, _    'show names   0-no 1-yes
      gShowborders As Long, _  'show borders 0-no 1-yes
      gShowpaths As Long, _    'show paths in filename 0-no 1-yes
      gTransparent As Long, _  'transparent image background
      gAutoSetRC As Long, _    'calculate row/column values for best fit
      gAutoRefresh As Long, _  'auto refresh file display
      gRefreshRate As Long, _  'refresh period (seconds)
      gUseini As Long)  'use INI file 0-no 1-yes

#Resource Icon logo         "files\gbmultiviewer.ico"
#Resource Icon xClear       "files\clear.ico"
#Resource Icon xDelete      "files\delete.ico"
#Resource Icon xCheckAll    "files\check.ico"
#Resource Icon xUnCheckAll  "files\uncheck.ico"
#Resource Icon xUnsupported "files\unsupported.ico"
#Resource Icon xsettings    "files\settings.ico"
#Resource Icon xHelp        "files\help.ico"

$Ver = "1.01"

Type CustomColors
   c(15) As Long
End Type

Enum Equates Singular
   IDC_ListView = 500
   IDC_Toolbar

   IDT_Clear
   IDT_Delete
   IDT_CheckAll
   IDT_UnCheckAll
   IDT_Display
   IDT_Settings
   IDT_Help

   IDST_Title
   IDST_Logo
   IDST_Unsupported
   IDST_x
   IDST_y
   IDST_w
   IDST_h
   IDST_autosetrc
   IDST_rows
   IDST_columns
   IDST_cid
   IDST_stretchmode
   IDST_shownames
   IDST_showborders
   IDST_showpaths
   IDST_transparent
   IDST_useini
   IDST_font
   IDST_save
   IDST_bgcolor
   IDST_autorefresh
   IDST_refreshrate
   IDST_labelTitle
   IDST_labelLogo
   IDST_labelUnsupported
   IDST_labelx
   IDST_labelw
   IDST_labelcolumns
   IDST_labelcid
   IDST_labelrefreshrate
   IDST_labelbg
End Enum

Global hDlg,hFont,hFontT, sDlg,hListView,hToolbar,ghHook As Dword
Global CustomColorList As CustomColors
Global FontName, FontNameTemp, ViewerTitle, ViewerLogo, ViewerUnsupported As WStringZ * %Max_Path
Global BGColor, BGColorTemp, Rows, Columns, xViewer, yViewer, wViewer, hViewer, FontSize, FontAttr As Long
Global Stretched, ShowNames, ShowBorders, ShowPaths, Transparent, ViewerCID, UseINI As Long
Global sDlgSave, FontSizeTemp, FontAttrTemp, AutoSetRC, AutoRefresh, RefreshRate, SortDirection As Long

Function PBMain() As Long
   Dialog New Pixels, 0, "gbMultiViewer " + $ver,300,300,350,300, %WS_OverlappedWindow To hDlg
   Dialog Set Icon hDlg, "logo"
   DragAcceptFiles hDlg, %True
   CreateToolbar
   Control Add ListView, hDlg, %IDC_ListView,"", 10,55,280,110, %WS_TabStop Or %LVS_ShowSelAlways Or %LVS_Report Or %LVS_SingleSel, %WS_Ex_ClientEdge
   ListView Insert Column hDlg, %IDC_ListView, 1, "File Names", 280,0
   ListView Set StyleXX hDlg, %IDC_ListView, %LVS_Ex_GridLines Or %LVS_Ex_DoubleBuffer Or %LVS_Ex_FullRowSelect Or %LVS_Ex_CheckBoxes
   Control Handle hDlg, %IDC_ListView To hListView

   Dialog Show Modal hDlg Call DlgProc
End Function

CallBack Function DlgProc() As Long
   Local FileName As WStringZ * %Max_Path, i,w,h,iResult,iCount As Long, P As ToolTipText Ptr
   Select Case Cb.Msg
      Case %WM_InitDialog
         Font New "Tahoma", 8, 0 To hFontT
         Control Set Font hDlg, %IDC_Toolbar, hFontT
         BuildAcceleratorTable
         Settings_ini "get"
         Font New FontName, FontSize, FontAttr To hFont
         Control Set Font hDlg, %IDC_ListView, hFont
         RestoreSession
      Case %WM_Destroy
         Settings_ini "save"
         SaveSession
      Case %WM_Size
         Dialog Get Client hDlg To w,h
         Control Set Size hDlg, %IDC_ListView, w-20,h-60
         ListView Set Column hDlg, %IDC_ListView, 1, w-25
'      Case %WM_NCLButtonDblClk
'         ListView Get Select hDlg, %IDC_ListView To iResult
'         ListView Unselect hDlg, %IDC_ListView, 1
'         Function = 1
      Case %WM_DropFiles
         iCount = DragQueryFile(Cb.WParam, -1, ByVal 0, 0)
         For i = 0 To iCount-1
            DragQueryFile Cb.WParam, i, FileName, SizeOf(FileName)
            ListView Insert Item hDlg, %IDC_ListView, 1, 0, FileName
            ListView_SetCheckState hListView, 0, 1
            ListView Select hDlg, %IDC_ListView, 1
         Next i
         DragFinish Cb.WParam
       Case %WM_Notify
          Select Case Cb.NmId
               Case %IDT_Clear To %IDT_Help
                   Select Case Cb.NmCode
                      Case %TTN_GetDispInfo
                         P = Cb.LParam
                         @P.@lpszText = SetToolTips(Cb.NmId)
                   End Select
               Case %IDC_ListView
                   Select Case Cb.NmCode
                       Case %NM_DblClk
                           ListView Get Select hDlg, %IDC_ListView To iResult
                           ListView Get Text hDlg, %IDC_ListView, iResult, 1 To FileName
                           iResult = ShellExecute(hDlg, "Open", PathName$(Path,FileName), $Nul, $Nul, %SW_ShowNormal)
                       Case %LVN_ColumnClick
                           SortDirection = SortDirection Xor 1
                           If SortDirection Then
                              ListView Sort hDlg, %IDC_ListView, 1, UCase, Ascend
                           Else
                              ListView Sort hDlg, %IDC_ListView, 1, UCase, Descend
                           End If
                   End Select
         End Select

       Case %WM_Command
          Select Case Cb.Ctl
             Case %IDT_Display : ShowFiles
             Case %IDT_Clear   : ListView Reset hDlg, %IDC_ListView
             Case %IDT_Delete
                ListView Get Select hDlg, %IDC_ListView To iResult
                ListView Delete Item hDlg, %IDC_ListView, iResult
                ListView Get Count hDlg, %IDC_ListView To iCount
                If iResult > iCount Then iResult = iCount
                ListView Select hDlg, %IDC_ListView, iResult
             Case %IDT_CheckAll   : CheckAll(1)
             Case %IDT_UnCheckAll : CheckAll(0)
             Case %IDT_Settings   : DisplaySettingsDialog
             Case %IDT_Help
                FileName = "http://www.garybeene.com/sw/gbmultiviewer.htm"
                iResult = ShellExecute(hDlg, "Open", FileName, $Nul, $Nul, %SW_ShowNormal)
          End Select
   End Select
End Function

Sub CheckAll(Flag As Long)  '1 = checked  0 = unchecked
   Local i, iCount As Long
   ListView Get Count hDlg, %IDC_ListView To iCount
   For i = 1 To iCount
      ListView_SetCheckState hListView, i-1, Flag
   Next i
End Sub

Sub CreateToolbar
    Local hImageList As Dword
    ImageList New Icon 24,24,24,10 To hImageList
    ImageList Add Icon hImageList, "xclear"      '1
    ImageList Add Icon hImageList, "xdelete"     '2
    ImageList Add Icon hImageList, "xcheckall"   '3
    ImageList Add Icon hImageList, "xuncheckall" '4
    ImageList Add Icon hImageList, "logo"        '5
    ImageList Add Icon hImageList, "xhelp"       '6
    ImageList Add Icon hImageList, "xsettings"   '7

    Control Add Toolbar, hDlg, %IDC_Toolbar,"", 0,0,0,0, %TbStyle_Tooltips Or %TbStyle_Flat Or %WS_Child
    Control Handle hDlg, %IDC_Toolbar To hToolbar
    Toolbar Set ImageList hDlg, %IDC_Toolbar, hImageList, 0     'default imagelist

    Toolbar Add Button  hDlg, %IDC_Toolbar, 5, %IDT_Display,  %TbStyle_Button, "Display"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 5
    Toolbar Add Button  hDlg, %IDC_Toolbar, 1, %IDT_Clear,  %TbStyle_Button, "Clear"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 2, %IDT_Delete,  %TbStyle_Button, "Remove"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 5
    Toolbar Add Button  hDlg, %IDC_Toolbar, 3, %IDT_CheckAll,  %TbStyle_Button, "Check"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 4, %IDT_UnCheckAll,  %TbStyle_Button, "UnCheck"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 5
    Toolbar Add Button  hDlg, %IDC_Toolbar, 7, %IDT_Settings,  %TbStyle_Button, "Settings"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 5
    Toolbar Add Button  hDlg, %IDC_Toolbar, 6, %IDT_Help,  %TbStyle_Button, "Help"

End Sub

Function SetToolTips(cID As Long) As String
   Select Case cID          'or this:   @P.hdr.idFrom
      Case %IDT_Clear       : Function = "Delete All Items From List"
      Case %IDT_Delete      : Function = "Delete Selected Items From List"
      Case %IDT_CheckAll    : Function = "Check All Items"
      Case %IDT_UnCheckAll  : Function = "UnCheck All Items"
      Case %IDT_Settings    : Function = "Display Settings Dialog"
      Case %IDT_Help        : Function = "Open OnLine Help"
   End Select
End Function

Sub SaveSession
   Local i,iCount,iResult As Long, temp$, fName$
   ListView Get Count hDlg, %IDC_ListView To iCount
   fName$ = "session.dat"
   Open fName$ For Output As #1
   If iCount Then
      For i = iCount To 1 Step -1
         ListView Get Text hDlg, %IDC_ListView, i,1 To temp$
         Print #1, temp$
         iResult = ListView_GetCheckState(hListView,i-1)
         Print #1, Str$(iResult)
      Next i
   End If
   Close #1
End Sub

Sub RestoreSession
   Local fName$, temp$
   'read Paths()
   fName$ = "session.dat"
   If IsTrue(IsFile(fName$)) Then
      Open fName$ For Input As #1
      While IsFalse(Eof(1))
         Line Input #1, temp$
         ListView Insert Item hDlg, %IDC_ListView, 1, 0, temp$
         Line Input #1, temp$
         ListView_SetCheckState hListView, 0, Val(temp$)
      Wend
      Close #1
   End If
End Sub

Sub Settings_INI(Task$)
   Local i,x,y As Long, xResult, yResult, temp, INIFileName As WStringZ*%Max_Path
   INIFileName = Exe.Path$ + "gbmultiviewer.ini"
   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "300", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "300", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult), Val(yResult)   'left/top

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "345", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "300", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult), Val(yResult)   'width/height

      'get value for string variables
      Getprivateprofilestring "All", "FontName", "Tahoma", FontName, %Max_Path, INIFileName
      Getprivateprofilestring "All", "ViewerTitle", "gbMultiViewer", ViewerTitle, %Max_Path, INIFileName
      Getprivateprofilestring "All", "ViewerLogo", "logo", ViewerLogo, %Max_Path, INIFileName
      Getprivateprofilestring "All", "ViewerUnsupported", "unsupported", ViewerUnsupported, %Max_Path, INIFileName

      'get value for numeric variables
      Getprivateprofilestring "All", "FontSize", "8", temp, %Max_Path, INIFileName :  FontSize = Val(temp)
      Getprivateprofilestring "All", "FontAttr", "0", temp, %Max_Path, INIFileName :  FontAttr = Val(temp)
      Getprivateprofilestring "All", "BGColor", Str$(%White), temp, %Max_Path, INIFileName : BGColor = Val(temp)
      Getprivateprofilestring "All", "Rows", "2", temp, %Max_Path, INIFileName :  Rows = Val(temp)
      Getprivateprofilestring "All", "Columns", "3", temp, %Max_Path, INIFileName : Columns = Val(temp)
      Getprivateprofilestring "All", "xViewer", "100", temp, %Max_Path, INIFileName :  xViewer = Val(temp)
      Getprivateprofilestring "All", "yViewer", "100", temp, %Max_Path, INIFileName :  yViewer = Val(temp)
      Getprivateprofilestring "All", "wViewer", "400", temp, %Max_Path, INIFileName :  wViewer = Val(temp)
      Getprivateprofilestring "All", "hViewer", "400", temp, %Max_Path, INIFileName :  hViewer = Val(temp)
      Getprivateprofilestring "All", "StretchMode", "0", temp, %Max_Path, INIFileName :  Stretched = Val(temp)
      Getprivateprofilestring "All", "ShowNames", "1", temp, %Max_Path, INIFileName :  ShowNames = Val(temp)
      Getprivateprofilestring "All", "ShowBorders", "1", temp, %Max_Path, INIFileName :  ShowBorders = Val(temp)
      Getprivateprofilestring "All", "ShowPaths", "0", temp, %Max_Path, INIFileName :  ShowPaths = Val(temp)
      Getprivateprofilestring "All", "Transparent", "0", temp, %Max_Path, INIFileName :  Transparent = Val(temp)
      Getprivateprofilestring "All", "ViewerCID", "5000", temp, %Max_Path, INIFileName :  ViewerCID = Val(temp)
      Getprivateprofilestring "All", "UseINI", "1", temp, %Max_Path, INIFileName :  UseINI = Val(temp)
      Getprivateprofilestring "All", "AutoSetRC", "1", temp, %Max_Path, INIFileName :  AutoSetRC = Val(temp)
      Getprivateprofilestring "All", "AutoRefresh", "0", temp, %Max_Path, INIFileName :  AutoRefresh = Val(temp)
      Getprivateprofilestring "All", "RefreshRate", "10", temp, %Max_Path, INIFileName :  RefreshRate = Val(temp)

      For i = 0 To 15
         Getprivateprofilestring "Custom", "CustomColor" + Format$(i,"00"), "", temp, %Max_Path, INIFileName
         CustomColorList.c(i) = Val(temp)
      Next i

   End If

   If Task$ = "save" Then
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If
      'save string variables
      WritePrivateProfileString "All", "FontName",FontName, INIFileName
      WritePrivateProfileString "All", "ViewerTitle",ViewerTitle, INIFileName
      WritePrivateProfileString "All", "ViewerLogo",ViewerLogo, INIFileName
      WritePrivateProfileString "All", "ViewerUnspported",ViewerUnsupported, INIFileName

      'save numeric variables
      WritePrivateProfileString "All", "FontSize", (Str$(FontSize)), INIFileName
      WritePrivateProfileString "All", "FontAttr", (Str$(FontAttr)), INIFileName
      WritePrivateProfileString "All", "BGColor", (Str$(BGColor)), INIFileName
      WritePrivateProfileString "All", "Rows", (Str$(Rows)), INIFileName
      WritePrivateProfileString "All", "Columns", (Str$(Columns)), INIFileName
      WritePrivateProfileString "All", "xViewer", (Str$(xViewer)), INIFileName
      WritePrivateProfileString "All", "yViewer", (Str$(yViewer)), INIFileName
      WritePrivateProfileString "All", "wViewer", (Str$(wViewer)), INIFileName
      WritePrivateProfileString "All", "hViewer", (Str$(hViewer)), INIFileName
      WritePrivateProfileString "All", "StretchMode", (Str$(Stretched)), INIFileName
      WritePrivateProfileString "All", "ShowNames", (Str$(ShowNames)), INIFileName
      WritePrivateProfileString "All", "ShowBorders", (Str$(ShowBorders)), INIFileName
      WritePrivateProfileString "All", "ShowPaths", (Str$(ShowPaths)), INIFileName
      WritePrivateProfileString "All", "Transparent", (Str$(Transparent)), INIFileName
      WritePrivateProfileString "All", "ViewerCID", (Str$(ViewerCID)), INIFileName
      WritePrivateProfileString "All", "UseINI", (Str$(UseINI)), INIFileName
      WritePrivateProfileString "All", "AutoSetRC", (Str$(AutoSetRC)), INIFileName
      WritePrivateProfileString "All", "AutoRefresh", (Str$(AutoRefresh)), INIFileName
      WritePrivateProfileString "All", "RefreshRate", (Str$(RefreshRate)), INIFileName

      For i = 0 To 15
         WritePrivateProfileString "Custom", "CustomColor" + Format$(i,"00"), Str$(CustomColorList.c(i)), INIFileName
      Next
   End If
End Sub

Sub ShowFiles
   Local FileList, FileName As String, i,iCount As Long
   'create file list
   ListView Get Count hDlg, %IDC_ListView To iCount
   For i = iCount To 1 Step -1
      If ListView_GetCheckState(hListView,i-1) Then
         ListView Get Text hDlg, %IDC_ListView, i, 1 To FileName
         FileList = FileName + ";" + FileList
      End If
   Next i
   FileList = Trim$(FileList,";")
   If Len(FileList) = 0 Then MsgBox "No file selected!", %MB_Ok + %MB_IconExclamation, "View Files" : Exit Sub

   'open the viewer
   gViewer ViewerTitle, _         'title to use in dialog
           hDlg, _                'parent handle
           FileList, _            'file list, semicolon separated
           ViewerLogo, _          'resource icon for gbMultiViewer dialog
           ViewerUnsupported, _   'resource icon for unsupported file types
           xViewer, _             'x position relative to parent upper-left
           yViewer, _             'y position relative to parent upper-left
           wViewer, _             'viewer width
           hViewer, _             'viewer height
           columns, _             'columns
           rows, _                'rows
           viewercid, _           'control ID starting value
           BGColor, _             'background color
           stretched, _           'display mode  0-upperleft 1-center/resized(stretched)
           shownames, _           'show names    0-no 1-yes
           showborders, _         'show borders  0-no 1-yes
           showpaths, _           'show paths in filename 0-no 1-yes
           transparent, _         'transparent image background
           autosetrc, _           'calculate row/column values for best fit
           autorefresh, _         'automatically refreshes dislayed files
           refreshrate, _         'refresh period (seconds)
           useini                 'use INI file  0-no 1-yes
End Sub

Sub DisplaySettingsDialog()
   Dialog New Pixels, hDlg, "gbMultiViewer Settings", 50, 90, 230,410, %WS_SysMenu To sDlg
   Dialog Set Icon sDlg, "xsettings"

   'Title, Dialog icon, Unsupported icon
   Control Add Label, sDlg, %IDST_LabelTitle,"Viewer Caption",10,10,100,20
   Control Add TextBox, sDlg, %IDST_Title, ViewerTitle, 120,10,100,20
   Control Add Label, sDlg, %IDST_LabelLogo,"Viewer Logo",10,35,100,20
   Control Add TextBox, sDlg, %IDST_Logo, ViewerLogo, 120,35,100,20
   Control Add Label, sDlg, %IDST_LabelUnsupported,"Unsupported Image",10,60,100,20
   Control Add TextBox, sDlg, %IDST_Unsupported, ViewerUnsupported, 120,60,100,20

   'xy wh
   Control Add Label, sDlg, %IDST_LabelX,"Dialog XY Position",10,85,120,20
   Control Add TextBox, sDlg, %IDST_x, Str$(xViewer), 120,85,45,20
   Control Add TextBox, sDlg, %IDST_y, Str$(yViewer), 170,85,45,20
   Control Add Label, sDlg, %IDST_LabelW,"Dialog Width/Height",10,110,120,20
   Control Add TextBox, sDlg, %IDST_w, Str$(wViewer), 120,110,45,20
   Control Add TextBox, sDlg, %IDST_h, Str$(hViewer), 170,110,45,20

   'rows/columns
   Control Add Label, sDlg, %IDST_LabelColumns,"Columns/Rows",10,135,120,20
   Control Add TextBox, sDlg, %IDST_columns, Str$(Columns), 120,135,45,20
   Control Add TextBox, sDlg, %IDST_rows, Str$(Rows), 170,135,45,20

   'cid
   Control Add Label, sDlg, %IDST_LabelCID,"Starting Control ID",10,160,140,20
   Control Add TextBox, sDlg, %IDST_cid, Str$(ViewerCID), 120,160,95,20

   'color
   Control Add Label, sDlg, %IDST_LabelBG, "Image BG Color", 10,185,120,20
   Control Add Label, sDlg, %IDST_BGColor,"",120,185,20,20, %WS_Border Or %SS_Notify
   Control Set Color SDlg, %IDST_BGColor, BGColor, BGColor

   'options
   Control Add CheckBox, sDlg, %IDST_stretchmode, "Stretch Mode", 10,210,145,20
   Control Add CheckBox, sDlg, %IDST_shownames, "Show Names", 10,230,145,20
   Control Add CheckBox, sDlg, %IDST_useini, "Use INI", 10,250,145,20
   Control Add CheckBox, sDlg, %IDST_showborders, "Show Image Borders", 10,270,145,20
   Control Add CheckBox, sDlg, %IDST_showpaths, "Show Paths In File Names", 10,290,145,20
   Control Add CheckBox, sDlg, %IDST_transparent, "Transparent Image Background", 10,310,180,20
   Control Add CheckBox, sDlg, %IDST_autosetrc, "AutoSet Row/Columns", 10,330,180,20
   Control Add CheckBox, sDlg, %IDST_autorefresh, "Periodic File Refresh", 10,350,120,20
   Control Add TextBox,  sDlg, %IDST_refreshrate, "", 140,350,40,20
   Control Add Label,    sDlg, %IDST_Labelrefreshrate,"(sec)",185,350,30,20

   'font
   Control Add Button, sDlg, %IDST_font, "Font  (" + FontName + Str$(FontSize)+ ")", 10,375,150,20

   Control Add Button, sDlg, %IDST_Save, "Save && Exit", 140, 210, 75, 25
   Control Add Button, sDlg, %IdCancel, "Cancel", 140, 245, 75, 25

   Dialog Show Modal sDlg Call SettingsProc()
End Sub

CallBack Function SettingsProc() As Long
   Local i As Long
   Select Case Cb.Msg
      Case %WM_InitDialog
         sDlgSave = 1
         For i = %IDST_Title To %IDST_LabelBG : Control Set Font sDlg, i, hFontT : Next i
         Control Set Font sDlg, %IdCancel, hFontT
         InitializeSettingsDialog
      Case %WM_Destroy
         If sDlgSave Then SaveSettingsDialog
         sDlg = 0
      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDST_Font
               SelectMainFont FontNameTemp, FontSizeTemp, FontAttrTemp
               Control Set Text sDlg, %IDST_Font, "Font  (" + FontNameTemp + Str$(FontSizeTemp)+ ")"
            Case %IDST_Save
               Dialog End sDlg
            Case %IdCancel
               sDlgSave = 0
               Dialog End sDlg
            Case %IDST_BGColor
               BGColorTemp = SelectColor(BGColorTemp)
               Control Set Color sDlg, %IDST_BGColor, BGColorTemp, BGColorTemp
               Control ReDraw sDlg, %IDST_BGColor
         End Select
   End Select
End Function

Sub InitializeSettingsDialog
   'textbox content was set when textboxes were created
    Control Set Check sDlg, %IDST_StretchMode, Stretched
    Control Set Check sDlg, %IDST_ShowNames, ShowNames
    Control Set Check sDlg, %IDST_ShowBorders, ShowBorders
    Control Set Check sDlg, %IDST_ShowPaths, ShowPaths
    Control Set Check sDlg, %IDST_Transparent, Transparent
    Control Set Check sDlg, %IDST_UseINI, UseINI
    Control Set Check sDlg, %IDST_AutoSetRC, AutoSetRc
    Control Set Check sDlg, %IDST_AutoRefresh, AutoRefresh

    Control Set Text sDlg, %IDST_RefreshRate,Str$(RefreshRate)

    BGColorTemp = BGColor
    Control Set Color sDlg, %IDST_BGColor, BGColorTemp, BGColorTemp

    FontNameTemp = FontName
    FontSizeTemp = FontSize
    FontAttrTemp = FontAttr
End Sub

Sub SaveSettingsDialog
   Local temp$
    Control Get Text sDlg, %IDST_Title To ViewerTitle
    Control Get Text sDlg, %IDST_Logo To ViewerLogo
    Control Get Text sDlg, %IDST_Unsupported To ViewerUnsupported

    Control Get Text sDlg, %IDST_x To temp$ : xViewer = Val(temp$)
    Control Get Text sDlg, %IDST_y To temp$ : yViewer = Val(temp$)
    Control Get Text sDlg, %IDST_w To temp$ : wViewer = Val(temp$)
    Control Get Text sDlg, %IDST_h To temp$ : hViewer = Val(temp$)

    Control Get Text sDlg, %IDST_rows To temp$ : rows = Val(temp$)
    Control Get Text sDlg, %IDST_columns To temp$ : columns = Val(temp$)

    Control Get Text sDlg, %IDST_cid To temp$ : ViewerCID = Val(temp$)

    Control Get Check sDlg, %IDST_StretchMode To Stretched
    Control Get Check sDlg, %IDST_ShowNames To ShowNames
    Control Get Check sDlg, %IDST_ShowBorders To ShowBorders
    Control Get Check sDlg, %IDST_ShowPaths To ShowPaths
    Control Get Check sDlg, %IDST_Transparent To Transparent
    Control Get Check sDlg, %IDST_UseINI To UseINI
    Control Get Check sDlg, %IDST_AutoSetRC To AutoSetRC
    Control Get Check sDlg, %IDST_AutoRefresh To AutoRefresh

    Control Get Text sDlg, %IDST_RefreshRate To temp$ : RefreshRate = Val(temp$)

    BGColorTemp = BGColor
    FontName = FontNameTemp
    FontSize = FontSizeTemp
    FontAttr = FontAttrTemp
    Font New FontName, FontSize, FontAttr To hFont
    Control Set Font hDlg, %IDC_ListView, hFont

End Sub

Function SelectColor(startcolor&) As Long    'works on pControl
   Local ColorResult&
   Display Color hDlg, 200, 200, startcolor&, CustomColorList , 0 To ColorResult&
   If ColorResult& = -1 Then Function = startcolor& Else Function = ColorResult&
End Function

Sub SelectMainFont(FFontName As WStringZ * %Max_Path, FFontSize As Long, FFontAttr As Long)
   Local fName As String, fPoints, fStyle, fColor, CharSet, Style As Long
   Style = %CF_ScreenFonts Or %CF_ForceFontExist Or %CF_NoScriptSel Or %CF_NoSimulations 'Or IIf(FixedPitch,%CF_FixedPitchOnly,0)
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(FontDialogProc), GetModuleHandle(""), GetCurrentThreadId)
   Display Font hDlg, 100,100, FFontName, FFontSize, FFontAttr, Style To fName, fPoints, fStyle, fColor, CharSet
   If Len(fName) Then
      FFontName = fName : FFontSize = fPoints : FFontAttr = fStyle
   End If
End Sub

Function FontDialogProc(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Local szTemp As WStringZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr
    Function = CallNextHookEx(ByVal ghHook, ByVal nCode, ByVal wParam, ByVal lParam)
    If nCode < 0 Then Exit Function
    If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx ghHook
    If nCode = %HCBT_CREATEWND Then
        cw = lParam         ' Get pointer to CBT_CREATEWND struct so we can...    TT: Nick Melnick
        cst = @cw.lpcs      ' get a pointer to the CREATESTRUCT struct
        GetClassName wParam, szTemp, %Max_Path      ' for each window / control as it is created
        If UCase$(szTemp) = "#32770" Then @cst.cy = @cst.cy - 165 : @cst.cx = @cst.cx - 10  'dialog
    End If
End Function

Function MsgProc(ByVal lMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local x As Long, y As Long    'MsgBox is approximately 200x200
   CenterOverDialog 200,200,x,y
   If lMsg = %HCBT_ACTIVATE Then
      SetWindowPos wParam, 0, x,y, 0, 0, %SWP_NOSIZE Or %SWP_NOACTIVATE Or %SWP_NOZORDER
      UnhookWindowsHookEx ghHook
   End If
End Function

Sub CenterOverDialog(BoxX As Long, BoxY As Long, CenterX As Long, CenterY As Long)
   'gets top/left position to center Box over Dialog
   'you need to know, or at least estimate, the Box size
   Local x As Long, y As Long, w As Long, h As Long
   Dialog Get Loc hDlg To x,y
   Dialog Get Size hDlg To w,h
   CenterX = x + (w-BoxX)/2
   CenterY = y + (h-BoxY)/2
End Sub

Sub BuildAcceleratorTable
   Local c As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
   Dim ac(2)
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_F1     : ac(c).cmd   = %IDT_Help       : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_M      : ac(c).cmd   = %IDT_Display    : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_S      : ac(c).cmd   = %IDT_Settings  : Incr c
   Accel Attach hDlg, AC() To hAccelerator
End Sub
