#Compile DLL "gbmultiviewer.dll"
#Dim All
%Unicode = 1
#Include "win32api.inc"

#Resource Icon dlllogo         "files\gbmultiviewer.ico"
#Resource Icon dllunsupported  "files\unsupported.ico"

$Ver = "1.00"

'=============================
Type GdiplusStartupInput Dword
   GdiplusVersion           As Dword
   DebugEventCallback       As Dword
   SuppressBackgroundThread As Long
   SuppressExternalCodecs   As Long
End Type

Type GdiplusStartupOutput Dword
   NotificationHook   As Dword
   NotificationUnhook As Dword
End Type

Declare Function GdiplusStartup Lib "gdiplus.dll" Alias "GdiplusStartup" (ByRef token As Dword, ByRef Input As GdiplusStartupInput, ByRef Output As GdiplusStartupOutput) As Long
Declare Sub GdiplusShutdown Lib "gdiplus.dll" Alias "GdiplusShutdown" (ByVal token As Dword)
Declare Function GdipLoadImageFromFile Lib "gdiplus.dll" Alias "GdipLoadImageFromFile" (ByVal filename As Dword, ByRef Image As Dword) As Long
Declare Function GdipGetImageWidth Lib "GDIPLUS.DLL" Alias "GdipGetImageWidth" (ByVal Image As Dword, ByRef Width As Dword) As Long
Declare Function GdipGetImageHeight Lib "GDIPLUS.DLL" Alias "GdipGetImageHeight" (ByVal Image As Dword, ByRef height As Dword) As Long
Declare Function GdipCreateFromHDC Lib "gdiplus.dll" Alias "GdipCreateFromHDC" (ByVal hdc As Dword, ByRef graphics As Dword) As Long
Declare Function GdipDrawImage Lib "gdiplus.dll" Alias "GdipDrawImage"(ByVal graphics As Dword, ByVal Image As Dword, ByVal x As Single, ByVal y As Single) As Long                                              ' GpStatus
Declare Function GdipDisposeImage Lib "gdiplus.dll" Alias "GdipDisposeImage" (ByVal Image As Dword) As Long
Declare Function GdipDeleteGraphics Lib "gdiplus.dll" Alias "GdipDeleteGraphics" (ByVal graphics As Dword) As Long
'=============================

Type gCustomColors
   c(15) As Long
End Type

Type gProp   'dialog data
   title As StringZ * %Max_Path
   hWin As Dword
   parent As Dword
   logo As StringZ * %Max_Path
   unsupported As StringZ * %Max_Path
   x As Long              'x posiiton relative to parent
   y As Long              'y position relative to parent
   w As Long              'viewer dialog width
   h As Long              'viewer dialog height
   r As Long              'r columns
   c As Long              's rows
   cidMin As Long         'minimum control ID
'-------------------------------------------------------------------
   bgColor As Long        'INI var. bgcolor of images only
   transparent As Long    'INI var. 1=transparent  0=not
   stretched As Long      'INI var. 0=upper left   1=centered/resized
   shownames As Long      'INI var. 1=show name 0=not
   useini As Long         'INI var. 1=useINI    0=not
   showborders As Long    'INI var. 1=image borders  0=none
   showpaths As Long      'INI var. 0=namex only 1=fullpath
   autorefresh As Long    'INI var. 0=off 1=on
   refreshrate As Long    'INI var. refresh period (seconds)
'-------------------------------------------------------------------
   font As Dword          'temp var. font common to all textboxes
   token As Dword         'temp var. GDIP
   oldproc As Dword       'temp var. subclassing
   hContext As Dword      'temp var. context menu common to all textboxes
   hContextB As Dword     'temp var. dialog context menu
   contextcid As Dword    'temp var. handle of control which launch context menu
   timercounter As Long   'temp var. timer counter
   ghHook As Dword        'temp var. hook handle
End Type

Type gData   'control data
   x As Long
   y As Long
   w As Long
   h As Long
   filename As StringZ * %Max_Path
   cid      As Long
   lblcid   As Long
   filetype As Long  '0=text 1=img
   wImg As Long
   hImg As Long
End Type

Enum gEquates Singular
   gFixed       = 0
   gStretch     = 1
   gText        = 0
   gBMP         = 1
   gIcon        = 2
   gOtherImage  = 3
   gUnsupported = 4
   IDM_gCut            = 500
   IDM_gCopy
   IDM_gPaste
   IDM_gDelete
   IDM_gDisplayMode
   IDM_gBGColor
   IDM_gTransparent
   IDM_gSep
   IDM_gShowNames
   IDM_gShowBorders
   IDM_gShowPaths
   IDM_gOpenFile
   IDM_gOpenFolder
   IDM_gAutoRefresh
   IDM_gRefreshRate
   gTimer
End Enum

Global gP As gProp, gD() As gData, gC As gCustomColors, gS As String

Sub gViewer Alias "gViewer" (gTitle As WStringZ * %Max_Path, _        'title to use in dialog
            gParent As Dword, _                      'handle to parent of viewer dialog
            gFileList As String, _                   'file list, semicolon separated
            gLogo As WStringZ * %Max_Path, _         'resource icon for gbMultiViewer dialog
            gUnsupported As WStringZ * %Max_Path, _  'resource icon for unsupported file types
            gx As Long, _            'x position relative to parent upper-left
            gy As Long, _            'y position relative to parent upper-left
            gw As Long, _            'viewer width
            gh As Long, _            'viewer height
            gColumns As Long, _      'columns
            gRows As Long, _         'rows
            gCIDmin As Long, _       'control ID starting value
            gBGColor As Long, _      'background color
            gStretched As Long, _    'dislpay mode 0-upperleft 1-center/resized(stretched)
            gShownames As Long, _    'show names   0-no 1-yes
            gShowborders As Long, _  'show borders 0-no 1-yes
            gShowpaths As Long, _    'show paths in filename 0-no 1-yes
            gTransparent As Long, _  'transparent image background
            gAutoSetRC As Long, _    'calculate row/column values for best fit
            gAutoRefresh As Long, _  'auto refresh file display
            gRefreshRate As Long, _  'refresh period (seconds)
            gUseini As Long) Export  'use INI file 0-no 1-yes

   Local i,iCount As Long
   gP.title = gtitle : gP.parent = gparent : gS = gfilelist

   'gP.logo = glogo
   gP.Logo = "dlllogo"
   'gP.unsupported = gunsupported
   gP.unsupported = "dllunsupported"

   gP.x = gx : gP.y = gy : gP.w = gw : gP.h = gh

   gP.r = grows : gP.c = gcolumns
   If gAutoSetRC Then
      iCount = ParseCount(gS,";")
      For i = 1 To 1000
         If i*i >= iCount Then
            gP.c = i : gP.r = iCount / gP.c
            If gP.c * gP.r < iCount Then Incr gP.r
            Exit For
         End If
      Next i
   End If
   ReDim gD(1 To gP.r, 1 To gP.c)

   gP.cidMin = gcidmin : gP.cidMin = Max(0,5000)
   gP.bgColor = gbgcolor
   gP.stretched = gstretched
   gP.shownames = gshownames
   gP.showborders = gshowborders
   gP.showpaths = gshowpaths
   gP.transparent = gtransparent
   gP.autorefresh = gautorefresh
   gP.refreshrate = grefreshrate
   gP.useINI = guseini

   ' Initialize GDI+
   Local StartupInput As GdiplusStartupInput
   StartupInput.GdiplusVersion = 1
   GdiplusStartup(gP.token, StartupInput, ByVal %NULL)

   Dialog New Pixels, gParent, gP.Title, gP.x,gP.y,gP.w,gP.h, %WS_OverlappedWindow Or %WS_ClipSiblings Or %WS_ClipChildren To gP.hWin
   Dialog Set Icon gP.hWin, gP.logo
   Font New "Tahoma", 10, 0 To gP.font
   Dialog Show Modeless gP.hWin Call gMultiViewProc()
End Sub

CallBack Function gMultiViewProc() As Long
   Local r,c,x,y As Long, temp$
   Select Case Cb.Msg
      Case %WM_InitDialog
         If gP.useINI Then gSettings_INI "get"
         gBuildViewer
         gCreateCustomPopupMenu
         gSetMenus
         gManageTimer
         Dialog Post gP.hWin, %WM_User + 500, %Null, %Null

      Case %WM_User+500
         For c = 1 To gP.c
            For r = 1 To gP.r
               If gD(r,c).filetype = %gText Then
                  Control Set Focus gP.hWin, gD(r,c).cid
                  Control Post gP.hWin, gD(r,c).cid, %EM_SETSEL, 0, 0   'remove and textbox will be highlighted
               End If
            Next j
         Next i

      Case %WM_Destroy
         KillTimer gP.hWin, %gTimer
         GdiplusShutdown gP.token                                        ' Shutdown GDI+
         If gP.useINI Then gSettings_INI "save"

      Case %WM_Size
         gResizeWindow

      Case %WM_Timer
         Incr gP.TimerCounter
         If gP.TimerCounter = gP.RefreshRate Then
            gP.TimerCounter = 0
            For c = 1 To gP.c
               For r = 1 To gP.r
                  Control Kill gP.hWin, gD(r,c).cid
               Next r
            Next c            '
            ReDim gD(1 To gP.r, 1 To gP.c)
            gBuildViewer
            gResizeWindow
            Beep
         End If
         Dialog Set Text gP.hWin, gP.Title + Space$(10) + "Refresh in " + Str$(gP.RefreshRate - gP.TimerCounter) + " seconds"

      Case %WM_ContextMenu
         x = Lo(Integer,Cb.LParam) : y = Hi(Integer, Cb.LParam)    'WM_ContextMenu returns xy coordinates of mouse
         TrackPopupMenu gP.hContextB, %TPM_LeftAlign, x, y, 0, gP.hWin, ByVal 0   'put context menu where mouse is
         Function = 0 : Exit Function

      Case %WM_Command
         Select Case Cb.Ctl
              Case gP.cidMin To gP.cidMin + 2*ArrayAttr(gD(),4)+1
                 If Cb.CtlMsg = %STN_DblClk Then gOpenTarget(Cb.Ctl, 1)  'open folder

              Case %IDM_gCut    : SendMessage GetFocus, %WM_CUT, 0, 0
              Case %IDM_gCopy   : SendMessage GetFocus, %WM_COPY, 0, 0
              Case %IDM_gPaste  : SendMessage GetFocus, %WM_PASTE, 0, 0
              Case %IDM_gDelete : SendMessage GetFocus, %WM_CLEAR, 0, 0

              Case %IDM_gOpenFile   : gOpenTarget(0,0)  'open file
              Case %IDM_gOpenFolder : gOpenTarget(0,1)  'open folder

              Case %IDM_gTransparent
                 gP.transparent = gP.transparent Xor 1
                 gResizeWindow
                 gSetMenus

              Case %IDM_gBGColor
                 gP.bgColor = gSelectColor(gP.bgColor)
                 gP.transparent = 0
                 gResizeWindow
                 gSetMenus

              Case %IDM_gDisplayMode
                 gP.stretched = gP.stretched Xor 1
                 gResizeWindow
                 gSetMenus

              Case %IDM_gShowPaths
                 gP.showpaths = gP.showpaths Xor 1
                 gSetMenus
                 For c = 1 To gP.c
                    For r = 1 To gP.r
                       Control Set Text gP.hWin, gD(r,c).lblcid, IIf$(gP.showpaths, gD(r,c).filename, PathName$(Namex, gD(r,c).filename))
                    Next j
                 Next i
                 gResizeWindow

              Case %IDM_gShowBorders
                 gP.ShowBorders = gP.ShowBorders Xor 1
                 gSetMenus
                 For c = 1 To gP.c
                    For r = 1 To gP.r
                       If gD(r,c).fileType Then 'is image control
                          SetWindowLong GetDlgItem(gP.hWin,gD(r,c).cid), %GWL_STYLE, GetWindowLong (GetDlgItem(gP.hWin,gD(r,c).cid), %GWL_STYLE) Xor %WS_Border
                          SetWindowPos GetDlgItem(gP.hWin, gD(r,c).cid),0,0,0,0,0, %SWP_NoMove Or %SWP_NoSize Or %SWP_DrawFrame   'OR %SWP_FrameChanged
                       End If
                    Next j
                 Next i
                 gResizeWindow
                 Dialog ReDraw gP.hWin

              Case %IDM_gShowNames
                 gP.ShowNames = gP.ShowNames Xor 1
                 gSetMenus
                 For c = 1 To gP.c
                    For r = 1 To gP.r
                       Control Show State gP.hWin, gD(r,c).lblcid, IIf(gP.ShowNames,%SW_Show,%SW_Hide)
                    Next j
                 Next i
                 gResizeWindow

              Case %IDM_gAutoRefresh
                 gP.AutoRefresh = gP.AutoRefresh Xor 1
                 gSetMenus
                 gManageTimer

              Case %IDM_gRefreshRate
                 Dialog Get Loc gP.hWin To x,y
                 gP.ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProc), GetModuleHandle(""), GetCurrentThreadId)
                 temp$ = InputBox$("", "Refresh Rate (sec)", Str$(gP.RefreshRate), x+40,y+150)
                 If Len(temp$) Then gP.RefreshRate = Val(temp$)

         End Select

      Case %WM_Destroy
         For c = 1 To gP.c
            For r = 1 To gP.r
               If gD(r,c).filetype = 0 Then SetWindowLong GetDlgItem(gP.hWin,gD(r,c).cid), %GWL_WNDPROC, gP.OldProc   'un-subclass
            Next j
         Next i
   End Select
End Function

Sub gSettings_INI(Task$)
   Local x As Long, y As Long
   Local xResult, yResult, temp, INIFileName As WStringZ*%Max_Path
   INIFileName = Exe.Path$ + "viewer.ini"
   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "0", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "0", yResult, %Max_Path, INIFileName
      If Val(xResult) Then Dialog Set Loc gP.hWin, Val(xResult), Val(yResult)   'left/top

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "0", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "0", yResult, %Max_Path, INIFileName
      If Val(xResult) Then Dialog Set Size gP.hWin,Val(xResult), Val(yResult)   'width/height

      'get value for string variables
'      Getprivateprofilestring "All", "FileName", "", FileName, %Max_Path, INIFileName

      'get value for numeric variables
      Getprivateprofilestring "All", "BGColor", "-1", temp, %Max_Path, INIFileName
      If Val(temp) > -1 Then gP.bgColor = Val(temp)
      Getprivateprofilestring "All", "Stretched", "-1", temp, %Max_Path, INIFileName
      If Val(temp) > -1 Then gP.stretched = Val(temp)
      Getprivateprofilestring "All", "ShowNames", "-1", temp, %Max_Path, INIFileName
      If Val(temp) > -1 Then gP.shownames = Val(temp)
      Getprivateprofilestring "All", "ShowBorders", "-1", temp, %Max_Path, INIFileName
      If Val(temp) > -1 Then gP.showborders = Val(temp)
      Getprivateprofilestring "All", "ShowPaths", "-1", temp, %Max_Path, INIFileName
      If Val(temp) > -1 Then gP.showpaths = Val(temp)
      Getprivateprofilestring "All", "Transparent", "-1", temp, %Max_Path, INIFileName
      If Val(temp) > -1 Then gP.transparent = Val(temp)
      Getprivateprofilestring "All", "AutoRefresh", "-1", temp, %Max_Path, INIFileName
      If Val(temp) > -1 Then gP.autorefresh = Val(temp)

      For x = 0 To 15
         Getprivateprofilestring "Custom", "CustomColor" + Format$(x,"00"), "", temp, %Max_Path, INIFileName
         gC.c(x) = Val(temp)
      Next x

   End If

   If Task$ = "save" Then
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(gP.hWin) Or IsZoomed(gP.hWin)) Then
         Dialog Get Loc gP.hWin To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size gP.hWin To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If
      'save string variables
'      WritePrivateProfileString "All", "FileName",FileName, INIFileName

      'save numeric variables
      WritePrivateProfileString "All", "BGColor", (Str$(gP.bgColor)), INIFileName
      WritePrivateProfileString "All", "Stretched", (Str$(gP.stretched)), INIFileName
      WritePrivateProfileString "All", "ShowNames", (Str$(gP.shownames)), INIFileName
      WritePrivateProfileString "All", "ShowBorders", (Str$(gP.showborders)), INIFileName
      WritePrivateProfileString "All", "ShowPaths", (Str$(gP.showpaths)), INIFileName
      WritePrivateProfileString "All", "Transparent", (Str$(gP.transparent)), INIFileName
      WritePrivateProfileString "All", "AutoRefresh", (Str$(gP.stretched)), INIFileName
      For x = 0 To 15
         temp = Str$(gC.c(x))
         WritePrivateProfileString "Custom", "CustomColor" + Format$(x,"00"), temp, INIFileName
      Next
   End If
End Sub

Sub gResizeWindow
   Local r,c,wCont,hCont,wNew,hNew,x,y,w,h As Long, hBMP,hDC As Dword
   Dialog Get Client gP.hWin To gP.w, gP.h
   For c = 1 To gP.c
      For r = 1 To gP.r
         'calculate xy and wh properties of each control
         gD(r,c).w = gP.w / gP.c - 10
         gD(r,c).h = gP.h / gP.r - IIf(gP.ShowNames,40,10)
         gD(r,c).x = gP.w / gP.c * (c-1) + 5
         gD(r,c).y = gP.h / gP.r * (r-1) + 5

         If gP.ShowBorders Then
            gD(r,c).w = Max(gD(r,c).w,3) : gD(r,c).h = Max(gD(r,c).h,3)
            gD(r,c).x = Max(gD(r,c).x,3) : gD(r,c).y = Max(gD(r,c).y,3)
         End If

         'resize each display control
         Control Set Loc gP.hWin, gD(r,c).cid, gD(r,c).x, gD(r,c).y
         Control Set Size gP.hWIn, gD(r,c).cid, gD(r,c).w, gD(r,c).h
         'resize each label
         Control Set Loc gP.hWin, gD(r,c).lblcid, gD(r,c).x, gD(r,c).y + gD(r,c).h + 5
         Control Set Size gP.hWIn, gD(r,c).lblcid, gD(r,c).w, 20

         If gD(r,c).fileType Then
            'for images only
            Graphic Attach gP.hWin, gD(r,c).cid
            Graphic Color %Black, IIf(gP.transparent, -1, gP.bgColor)
            Graphic Clear
            'redraw image
            If gP.stretched = %gStretch Then            'stretch image to fit control
               Graphic Set StretchMode %HalfTone
               Graphic Get Client To wCont,hCont     'wCont,hCont = container size : hImg,wImg = original image size
               wNew = gD(r,c).wImg / Max(gD(r,c).wImg / wCont, gD(r,c).hImg / hCont)  'wNew,hNew = image size to fit in container
               hNew = gD(r,c).hImg / Max(gD(r,c).wImg / wCont, gD(r,c).hImg / hCont)  'wNew,hNew = image size to fit in container
               x = (gD(r,c).w-wNew)/2 - 1 : y = 0 '(gD(r,c).h-hNew)/2 - 1    'upper/left position so resized image is centered
               Select Case gD(r,c).fileType
                  Case %gIcon        : Graphic Render Icon gD(r,c).filename, (x,y)-(x+wNew-1,y+hNew-1)
                  Case %gUnsupported : Graphic Render Icon gP.unsupported, (5,5)-(gD(r,c).wImg+4,gD(r,c).hImg+4)
                  Case %gBMP         : Graphic Render Bitmap gD(r,c).filename, (x,y)-(x+wNew-1,y+hNew-1)
                  Case %gOtherImage  :
                     Graphic Bitmap New gD(r,c).wImg, gD(r,c).hImg To hBMP
                     Graphic Attach hBMP, 0
                     Graphic Color %Black, IIf(gP.transparent, -1, gP.bgColor)
                     Graphic Clear
                     Graphic Get DC To hDC
                     gLoadOtherImage(r,c,hDC)
                     Graphic Attach gP.hWin, gD(r,c).cid
                     Graphic Stretch hBMP, 0, (0,0)-(gD(r,c).wImg-1,gD(r,c).hImg-1) To (x,y)-(x+wNew-1,y+hNew-1)
               End Select
            Else    'fixed image size, starting in upper left corner of control
               Select Case gD(r,c).fileType
                  Case %gIcon        : Graphic Render Icon gD(r,c).filename, (0,0)-(gD(r,c).wImg-1,gD(r,c).hImg-1)
                  Case %gUnsupported : Graphic Render Icon gP.unsupported, (5,5)-(gD(r,c).wImg+4,gD(r,c).hImg+4)
                  Case %gBMP         : Graphic Render Bitmap gD(r,c).filename, (0,0)-(gD(r,c).wImg-1,gD(r,c).hImg-1)
                  Case %gOtherImage
                     Graphic Get DC To hDC
                     gLoadOtherImage(r,c,hDC)
               End Select
            End If
         End If

      Next j
   Next i
End Sub

Sub gLoadOtherImage(r As Long, c As Long, hDC As Dword)
   Local P As IconInfo,pImage,pGraphics As Dword, wFileName As WString
   'get image dimensions
   wFileName = gD(r,c).filename
   GdipLoadImageFromFile(StrPtr(wFileName), pImage)  'pImage - image object
   GdipCreateFromHDC(hDC, pGraphics)                        ' Create the Graphic object
   GdipDrawImage(pGraphics, pImage, 0, 0)                   ' Draw the image
   'GDIP cleanup
   If pImage Then GdipDisposeImage(pImage)
   If pGraphics Then GdipDeleteGraphics(pGraphics)
   Control ReDraw gP.hWin, gD(r,c).cid
End Sub

Function gGetFileText(fName As StringZ * %Max_Path) As String
   Local temp$
   If IsFalse(IsFile(fName)) Then Exit Function
   Open fName For Binary As #1
   Get$ #1, Lof(1), temp$
   Close #1
   Function = temp$
End Function

Sub gBuildViewer
   Local r,c,iCount,Style,w,h As Long, P As IconInfo,hBMP,hIcon,pImage,pGraphics As Dword, wFileName As WString
   style& = %WS_Child Or %WS_Visible Or %ES_MultiLine Or %WS_VScroll Or %ES_AutoHScroll _
            Or %WS_HScroll Or %ES_AutoVScroll Or %ES_WantReturn Or %WS_TabStop
   Dialog Get Client gP.hWin To gP.w, gP.h
   For r = 1 To gP.r
      For c = 1 To gP.c
         wFileName = Parse$(gS,";", iCount/2 + 1)
         If IsFalse(IsFile(wFileName)) Then Iterate For
         gD(r,c).filename = wFileName
         gD(r,c).cid = gP.cidMin + iCount
         iCount = iCount + 2
         'calculate xy and wh properties of each control
         gD(r,c).w = gP.w / gP.c - 10
         gD(r,c).h = gP.h / gP.r - IIf(gP.ShowNames,40,10)
         gD(r,c).x = gP.w / gP.c * (c-1) + 5
         gD(r,c).y = gP.h / gP.r * (r-1) + 5
         'create display controls. get image size for each image
         Select Case LCase$(Right$(gD(r,c).filename,4))
            Case ".txt", ".bas", ".inc" :
               gD(r,c).fileType = %gText
               Control Add TextBox, gP.hWin, gD(r,c).cid, gGetFileText(gD(r,c).filename), gD(r,c).x, gD(r,c).y, gD(r,c).w, gD(r,c).h, Style, %WS_Ex_ClientEdge
               Control Set Font gP.hWin, gD(r,c).cid, gP.font
               gP.oldproc = SetWindowLong(GetDlgItem(gP.hWin,gD(r,c).cid), %GWL_WndProc, CodePtr(gNewProc))  'subclass
            Case ".bmp"
               gD(r,c).fileType = %gBMP
               'load bitmap from file to memory bitmap, get dimensions
               Graphic Bitmap Load gD(r,c).filename, 0, 0 To hBMP
               Graphic Attach hBMP, 0
               Graphic Get Canvas To gD(r,c).wImg,gD(r,c).hImg
               Graphic Bitmap End
               Control Add Graphic, gP.hWin, gD(r,c).cid, "", gD(r,c).x, gD(r,c).y, gD(r,c).w, gD(r,c).h, gP.showborders * %WS_Border Or %SS_Notify
            Case ".ico"
               gD(r,c).fileType = %gIcon
               'get icon dimensions
               hIcon = LoadImage(GetModuleHandle(""), (gD(r,c).filename), %Image_Icon, 0, 0, %LR_LoadFromFile)
               GetIconInfo hIcon, P : DestroyIcon hIcon
               gD(r,c).wImg = P.xHotSpot*2 : gD(r,c).hImg = P.yHotSpot*2
               Control Add Graphic, gP.hWin, gD(r,c).cid, "", gD(r,c).x, gD(r,c).y, gD(r,c).w, gD(r,c).h, gP.showborders * %WS_Border Or %SS_Notify
            Case ".jpg", ".gif", ".png"
               gD(r,c).fileType = %gOtherImage
               'get image dimensions
               wFileName = gD(r,c).filename
               GdipLoadImageFromFile(StrPtr(wFileName), pImage)  'pImage - image object
               GdipGetImageWidth(pImage,gD(r,c).wImg)
               GdipGetImageHeight(pImage,gD(r,c).hImg)
               'GDIP cleanup
               If pImage Then GdipDisposeImage(pImage)
               If pGraphics Then GdipDeleteGraphics(pGraphics)
               'create display control
               Control Add Graphic, gP.hWin, gD(r,c).cid, "", gD(r,c).x, gD(r,c).y, gD(r,c).w, gD(r,c).h, gP.showborders * %WS_Border Or %SS_Notify
            Case Else 'unsupported
               gD(r,c).fileType = %gUnsupported
               hIcon = LoadImage(GetModuleHandle(""), (gP.Unsupported), %Image_Icon, 0, 0, %LR_DefaultColor)
               GetIconInfo hIcon, P : DestroyIcon hIcon
               gD(r,c).wImg = P.xHotSpot*2 : gD(r,c).hImg = P.yHotSpot*2
               Control Add Graphic, gP.hWin, gD(r,c).cid, "", gD(r,c).x, gD(r,c).y, gD(r,c).w, gD(r,c).h, gP.showborders * %WS_Border Or %SS_Notify
         End Select
         gD(r,c).lblcid = gD(r,c).cid + 1
         Control Add Label, gP.hWin, gD(r,c).lblcid, IIf$(gP.ShowPaths, gD(r,c).filename, PathName$(Namex, gD(r,c).filename)), gD(r,c).x, gD(r,c).y + gD(r,c).h + 15, gD(r,c).w, 20, %SS_Notify
         Control Set Font gP.hWin, gD(r,c).lblcid, gP.font
         If gP.ShowNames = 0 Then Control Show State gP.hWIn, gD(r,c).lblcid, %SW_Hide
      Next j
   Next i
End Sub

Function gNewProc(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local x As Long, y As Long
   Static iCOunt As Long
   Incr iCount
   Select Case Msg
      Case %WM_ContextMenu
         gP.contextcid = GetDlgCtrlID(wParam)
         x = Lo(Integer,lParam) : y = Hi(Integer, lParam)    'WM_ContextMenu returns xy coordinates of mouse
         TrackPopupMenu gP.hContext, %TPM_LeftAlign, x, y, 0, gP.hWin, ByVal 0   'put context menu where mouse is
         Function = 0 : Exit Function
   End Select
   Function = CallWindowProc(gP.oldproc, hWnd, Msg, wParam, lParam)
End Function

Sub gCreateCustomPopUpMenu
   Menu New PopUp To gP.hContextB
   Menu Add String, gP.hContextB, "Show File Names",   %IDM_gShowNames,  %MF_Enabled
   Menu Add String, gP.hContextB, "Show Paths in File Names",   %IDM_gShowPaths,  %MF_Enabled
   Menu Add String, gP.hContextB, "-", %IDM_gSep,  %MF_Enabled
   Menu Add String, gP.hContextB, "Stretch Mode",   %IDM_gDisplayMode,  %MF_Enabled
   Menu Add String, gP.hContextB, "Show Image Borders",   %IDM_gShowBorders,  %MF_Enabled
   Menu Add String, gP.hContextB, "Transparent Image Background",   %IDM_gTransparent,  %MF_Enabled
   Menu Add String, gP.hContextB, "-", %IDM_gSep,  %MF_Enabled
   Menu Add String, gP.hContextB, "Auto Refresh Files",   %IDM_gAutoRefresh,  %MF_Enabled
   Menu Add String, gP.hContextB, "-", %IDM_gSep,  %MF_Enabled
   Menu Add String, gP.hContextB, "Set Refresh Rate",   %IDM_gRefreshRate,  %MF_Enabled
   Menu Add String, gP.hContextB, "Set Image Background Color",   %IDM_gBGColor,  %MF_Enabled

   Menu New PopUp To gP.hContext
   Menu Add String, gP.hContext, "Copy",   %IDM_gCopy,  %MF_Enabled
   Menu Add String, gP.hContext, "Cut",    %IDM_gCut,  %MF_Enabled
   Menu Add String, gP.hContext, "Paste",  %IDM_gPaste,  %MF_Enabled
   Menu Add String, gP.hContext, "Delete", %IDM_gDelete,  %MF_Enabled
   Menu Add String, gP.hContext, "-", %IDM_gSep,  %MF_Enabled
   Menu Add String, gP.hContext, "Open File", %IDM_gOpenFile,  %MF_Enabled
   Menu Add String, gP.hContext, "Open Folder", %IDM_gOpenFolder,  %MF_Enabled
End Sub

Function gSelectColor(startcolor&) As Long    'works on pControl
   Local ColorResult&
   Display Color gP.hWin, 200, 200, startcolor&, gC , 0 To ColorResult&
   If ColorResult& = -1 Then Function = startcolor& Else Function = ColorResult&
End Function

Sub gSetMenus
    Menu Set State gP.hContextB, ByCmd %IDM_gShowNames, gP.shownames * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State gP.hContextB, ByCmd %IDM_gShowPaths, gP.showpaths * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State gP.hContextB, ByCmd %IDM_gDisplayMode, gP.stretched * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State gP.hContextB, ByCmd %IDM_gShowBorders, gP.showborders * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State gP.hContextB, ByCmd %IDM_gTransparent, gP.Transparent * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State gP.hContextB, ByCmd %IDM_gAutoRefresh, gP.AutoRefresh * (%MFS_Checked Or %MFS_Enabled)
End Sub

Sub gOpenTarget(CID As Dword, FolderFlag As Long)
   Local r,c As Long, temp$
   If CID = 0 Then CID = gP.contextcid
   Control Set Focus gP.hWin, GetDlgItem(gP.hWin,CID)
   For c = 1 To gP.c
      For r = 1 To gP.r
         If gD(r,c).cid = CID Or gD(r,c).lblcid = CID Then
            If FolderFlag Then
               temp$ = PathName$(Path,gD(r,c).fileName)
               r  = ShellExecute(gP.hWin, "Explore", (temp$), $Nul, $Nul, %SW_ShowNormal)
               Exit, Exit
           Else
               r  = ShellExecute(gP.hWin, "Open", (gD(r,c).filename), $Nul, $Nul, %SW_ShowNormal)
               Exit, Exit
            End If
         End If
      Next j
   Next i
End Sub

Sub gManageTimer
   If gP.AutoRefresh Then
      Dialog Set Text gP.hWin, gP.Title + Space$(10) + "Refresh in " + Str$(gP.RefreshRate - gP.TimerCounter) + " seconds"
      SetTimer gP.hWin, %gTimer, 1000, ByVal %Null
   Else
      KilLTimer gP.hWin, %gTimer
      Dialog Set Text gP.hWin, gP.Title
   End If
   gP.TimerCounter = 0
End Sub

Function InputBoxProc(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local szTemp As WStringZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr
   Function = CallNextHookEx(ByVal gP.ghHook, ByVal nCode, ByVal wParam, ByVal lParam)
   If nCode < 0 Then Exit Function
   If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx gP.ghHook
   If nCode = %HCBT_CREATEWND Then
      cw = lParam         ' Get pointer to CBT_CREATEWND struct so we can...    TT: Nick Melnick
      cst = @cw.lpcs      ' get a pointer to the CREATESTRUCT struct
      GetClassName wParam, szTemp, %Max_Path      ' for each window / control as it is created
      If UCase$(szTemp) = "BUTTON" Then @cst.x = 120  : @cst.cx = 60           'ok and cancel
      If UCase$(szTemp) = "STATIC" Then @cst.x = 400                           'prompt
      If UCase$(szTemp) = "EDIT"   Then @cst.cx = 100 : @cst.y = @cst.y - 130  'textbox
      If UCase$(szTemp) = "EDIT"   Then SetWindowLong wparam, %GWL_Style, GetWindowLong(wParam,%GWL_Style)
      If UCase$(szTemp) = "#32770" Then @cst.cx = 200 : @cst.cy = @cst.cy - 130                'dialog
   End If
End Function
